export declare const LayoutAlignMap: {
    auto: 0;
    baseline: 5;
    center: 2;
    'flex-end': 3;
    'flex-start': 1;
    'space-around': 7;
    'space-between': 6;
    stretch: 4;
};
export declare const DisplayMap: {
    none: 1;
    flex: 0;
};
export declare const FlexDirectionMap: {
    column: 0;
    'column-reverse': 1;
    row: 2;
    'row-reverse': 3;
};
export declare const FlexWrapMap: {
    'no-wrap': 0;
    wrap: 1;
    'wrap-reverse': 2;
};
export declare const JustifyContentMap: {
    center: 1;
    'flex-end': 2;
    'flex-start': 0;
    'space-around': 4;
    'space-between': 3;
    'space-evenly': 5;
};
export declare type NumberOrAuto = number | string | 'auto';
export interface LayoutAttrs {
    alignContent: keyof typeof LayoutAlignMap;
    alignItems: keyof typeof LayoutAlignMap;
    alignSelf: keyof typeof LayoutAlignMap;
    display: keyof typeof DisplayMap;
    flex: number;
    flexBasis: number | string;
    flexGrow: number;
    flexShrink: number;
    flexDirection: keyof typeof FlexDirectionMap;
    flexWrap: keyof typeof FlexWrapMap;
    height: NumberOrAuto;
    width: NumberOrAuto;
    justifyContent: keyof typeof JustifyContentMap;
    margin: NumberOrAuto | NumberOrAuto[];
    padding: number | string | (number | string)[];
    maxHeight: number;
    maxWidth: number;
    minHeight: number;
    minWidth: number;
    onClick: (e: Event) => void;
}
